'****************************************************************
'*  Name: niechaus_M.BAS               *                                      *
'****************************************************************   
Device = 16F877A
Xtal = 4
                                                                   
;-- --
                                                                   
Declare  SHOW_SYSTEM_VARIABLES = OFF   ; Proteus   
Declare  FSR_CONTEXT_SAVE = OFF   ;      FSR
Declare  Reminders = OFF    ;   
Declare  Warnings = OFF   ;   
                                                                   
;-- --
                                                                  
Declare  Adin_Res 10   ;   
Declare  Adin_Tad FRC  ;  
Declare  Adin_Stime  100
                                                                                                                             
;--  I2C--
                                                                   
Declare   SDA_Pin   PORTC.4
Declare   SCL_Pin   PORTC.3
Declare   Slow_Bus   OFF   ;   OSC > 4 
Declare   BUS_SCL   OFF    ;    SCL   
                                                                   
;-- --
                                                                   
Declare  PortB_Pullups = OFF   ;     PORTB
Declare  All_Digital = off ;       
                                                                 
'--   --
     
 TRISA = %00000001      '   PORTA.0    - 
 TRISE = %00000110      '   () AN5 (PORTE.50 , RE1, RE2 
 ADCON1 = %10000010     '    PORTA    
 TRISC = %11100100     ' PORTC.5/6/7 
 TRISD = %11111111     '   PORTD  
 TRISB = %11111111     '   PORT  

'---  ---
                                                       
Declare  LCD_Type ALPHA     
Declare  LCD_DTPin  PORTB.3   
Declare  LCD_ENPin  PORTB.3 
Declare  LCD_RSPin  PORTB.2 
Declare  LCD_Interface  4    
Declare  LCD_CommandUs  2000  
Declare  LCD_DataUs  50       
Declare  LCD_Lines   2     

'==    DS1307==

SCL VAR PORTC.3 '  clock 
SDA VAR PORTC.4 '  data
 
'Dim Ctrl As Byte
'Ctrl = %00010000 '    (  SOUT 1Hz)


rtc_read CON %11010000 '     
rtc_write con %11010001 '     
Dim sec As Byte '  
Dim sec1 As Byte '    
Dim sec2 As Byte
Dim mins As Byte '    DS1307 
Dim mins1 As Byte '     
Dim hr As Byte '    DS1307 
Dim hr1 As Byte '     
Dim day As Byte '   
Dim date As Byte '    DS1307 
Dim date1 As Byte '     
Dim mon As Byte '    DS1307 
Dim mon1 As Byte '     
Dim yr As Byte '    DS1307 
Dim yr1 As Byte 
Dim d_hi As Byte
Dim d_lo As Byte
Dim tmp As Byte 
Dim tmp1 As Byte    
                                                                  
'-- --
Dim Narab As Word
Dim N As Byte   ' .   
Dim NN As Word  ' .  
Dim NNN As Word ' .  
Dim NNN2 As Word ' .    

Dim D As Byte   ' .   
Dim VAR1 As Word  '       ADIn 5 
Dim VAR2 As Word  '       ADIn 6
Dim PROSThr As Byte  '   
Dim PROSTm As Byte   '   
Dim Prost As Word
Dim X As Byte 


Dim sec_ost As Byte  ' . 
Dim mins_ost As Byte ' . 
Dim hr_ost As Byte   ' . 
Dim date_ost As Byte ' . 
Dim mon_ost As Byte  ' . 
Dim yr_ost As Byte   ' .                  

Dim sec_start As Byte  ' . 
Dim mins_start As Byte ' . 
Dim hr_start As Byte   ' . 
Dim date_start As Byte ' . 
Dim mon_start As Byte  ' . 
Dim yr_start As Byte   ' .  
 
Dim address As Byte      '      
Dim address2 As Byte      '   
Dim Ukaz_daty As Byte  ' .       
Dim ukaz_dat As Byte  ' .   
Dim addr As Byte      ' .      

Dim f_obm As Word      '      
Dim sk_imp As Word      '   
Dim obr_imp As Word  ' .       
'Dim ukaz_dat As Byte  ' .   
'Dim addr As Byte      ' .      


    

'----
    
Init: 
Clear
Cls





'==========     ===============================
temperature    VAR	Word	'   
count_remain    VAR Byte	'  
count_per_c     VAR	Byte	'   C
DQ	VAR	PORTB.1	'  DS 1820
minus var Word


temperature1    VAR	Word	'  
count_remain1    VAR Byte	'  
count_per_c1     VAR	Byte	'   C
DQ1	VAR	PORTD.5	'  DS 1820
minus1 var Word

'================= ============================================
Dim value As Word  
'D var Word
B VAR Word
c var Word

A        VAR    Byte
I        VAR    Word            
J        VAR    Byte
K        VAR    Byte 
ACP      VAR    Byte        '     
T1       VAR    Byte        '    / 
dtk       var    Word
dtk1      var    Word
e        var    Word
g        var    Word
l        var    Word
m        var    Word

'======================  
rcxtpslitr   var Word
rcxtpsmililitr var Word

scrkm   var Word
scrmetr var Word

raskm   var Word
rasmetr var Word

Dim rastobtkm As Word
Dim rastobskm As Word
Dim rastobkm As Word

Dim rsxtopmgnlitr As Word
Dim rsxtopmgnmiliitr As Word




m=0
l=0
g=0
e=0
c=1
B=0
D=0 
dtk=1
dtk1=1
temperature=0
temperature1=0
value=0
X=1

'dim a as word 
'a = 5   
'ewrite 1,[a.highbyte] 
'ewrite 2,[a.lowbyte]   
'a.highbyte= eread, 1 
'a.lowbyte= eread, 2   


rastobkm=0



f_obm=ERead 2
pause 100      
sk_imp=ERead 3
pause 100  
obr_imp=ERead 4
pause  100

If f_obm>=1000 Then f_obm=0     
If sk_imp>=1000 Then sk_imp=0 
If obr_imp>=1000 Then obr_imp=0

'GoSub term 
'GoSub term1 






loop:

If  PORTD.3=0 Then 
pause 500
lcdout $fe,1
GoTo KNOPKI
EndIf




If  PORTD.2=0 Then 
pause 500
c=c+1
If c>10 Then c=1
If c<1 Then c=10
GoSub prosmotr
EndIf

If  PORTD.1=0 Then 
pause 500
c=c-1
If c>10 Then c=1
If c<1 Then c=10
GoSub prosmotr
EndIf






If c=1 Then 
pause 1000
GoSub read_time 
lcdout $fe,1 
GoSub PRNT3_4
EndIf


If c=2 Then 
GoSub oboroti
GoSub PRNTobor
EndIf

If c=3 Then 
g=g+1
If g>=60 Then g=0
If g=1 Then GoSub term '     
pause 100
GoSub term1 '     
GoSub temperatura
EndIf


If c=4 Then 
pause 1000
GoSub naprizenie
GoSub PRNTnaprizenie
EndIf

If c=5 Then
pause 1000
GoSub racx_toplseg
EndIf

If c=6 Then
pause 1000
GoSub scoroct
EndIf

If c=7 Then
pause 1000
GoSub prrasr_seg
EndIf

If c=8 Then
pause 1000
GoSub prrasr_obch
EndIf

If c=9 Then
pause 1000
GoSub racx_toplmgn
EndIf
  

GoTo loop


'===========================================================================
KNOPKI:
If PORTD.1 = 0 Then 
pause 500
X = X + 1 
If X > 4 Then X = 1
EndIf
   
If PORTD.2 = 0 Then 
pause 500
X = X - 1
If X = 0 Then X = 4
EndIf   
   
If X = 1 Then GoSub Rezim1
If X = 2 Then GoSub Rezim2
If X = 3 Then GoSub Rezim3
If X = 4 Then GoSub Rezim4
          
If X = 1 And PORTD.0 = 0 Then 
lcdout $fe,1
pause 500
GoTo loop
EndIf
   
If X = 3 And PORTD.0 = 0 Then 
lcdout $fe,1
GoSub read_time
pause 500 
X = 0
'sec1=1 
'mins1=1 
'hr1=1 
'date1=1 
'mon1=1 
'yr1=1
GoTo UstVREMY
EndIf   
   
   
   
If X = 2 And PORTD.0 = 0 Then 
'lcdout $fe,1
'pause 500
X = 0
'ukaz_dat = Ukaz_daty:
GoTo Fors_ckor
EndIf



If X = 4 And PORTD.0 = 0 Then 
'lcdout $fe,1
'pause 500
X = 0
'NNN2 = NNN:
'GoTo Redakt_narab 
EndIf

GoTo KNOPKI 
'============================================================================


Rezim1: '   
lcdout $fe,1
Print At 1 ,1,$42,$AE,$58,$4F,$E0,$20,$A5,$A4,$20,$50,$45,$A3,$A5,$4D,$41
Print At 2 ,1,$20,$20,$20,$A9,$43,$54,$41,$48,$4F,$42,$4B,$A5
DelayMS 500
Return

Rezim2:'    
lcdout $fe,1
Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$E0,$41,$48,$48,$AE,$58
Print At 2 ,1,$AA,$4F,$50,$43,$A9,$48,$2E,$2D,$43,$4B,$4F,$50,$4F,$43,$54,$A5
DelayMS 500
Return

Rezim3:  '    
lcdout $fe,1
Print At 1 ,1,$20,$20,$20,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41
Print At 2 ,1,$20,$20,$42,$50,$45,$4D,$45,$48,$A5,$2D,$E0,$41,$54,$AE
DelayMS 500
Return

Rezim4:
lcdout $fe,1
Print At 1 ,1,$A8,$4F,$A8,$50,$41,$42,$4B,$A5,$20,$50,$41,$43,$54,$4F,$B1,$48
Print At 2 ,1,$50,$41,$43,$58,$4F,$E0,$41,$20,$54,$4F,$A8,$A7,$A5,$42,$41
DelayMS 500
Return
'==================================================================================

    UstVREMY:
    pause 300
    BranchL X, [Ust_godov, Ust_mesacev, Ust_dney, Ust_chasov, Ust_minut, Ust_secund]
    If PORTD.0 = 0 Then 
    lcdout $fe,1
    pause 300
    lcdout $FE,$0C
    GoTo loop 
    EndIf 
    GoTo UstVREMY    
'============================================================================
  Ust_godov:
        If PORTD.2 = 0 Then 
        pause 100 
        yr1 = yr1 + 1 
        If yr1 >=100 Then yr1 = 99
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100
        yr1 = yr1 - 1 
        If yr1 <=0 Then yr1 = 0  
        EndIf   
           
        GoSub god_ust 

        If PORTD.0 = 0 Then
        lcdout $fe,1
        Pause 300:
        X = 1 
        GoTo UstVREMY
        EndIf
  GoTo Ust_godov
'==========================================================================
  Ust_mesacev:
        If PORTD.2 = 0 Then 
        pause 100
        mon1 = mon1 + 1
        If mon1 >= 13 Then mon1 = 12
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100
        mon1 = mon1 - 1 
        If mon1 <=0 Then mon1 = 1 
        EndIf
        
        GoSub mes_ust 
              
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300:
        X = 2 
        GoTo UstVREMY 
        EndIf
  GoTo Ust_mesacev
'=============================================================================  
  Ust_dney: 
          'pause 1000
        If PORTD.2 = 0 Then 
        Pause 100 
        date1 = date1 + 1 
        If date1 >= 32 Then date1 = 31
        EndIf
        
        If PORTD.1 = 0 Then 
        Pause 100
        date1 = date1 - 1 
        If date1 <= 0 Then date1 = 1 
        EndIf
         
        GoSub date_ust 
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1
        pause 300 
        X = 3
        GoTo UstVREMY
        EndIf
  GoTo Ust_dney
'=============================================================================  
  Ust_chasov:
       ' pause 500
        If PORTD.2 = 0 Then 
        pause 100 
        hr1 = hr1 + 1 
        If hr1>=24 Then hr1=23
        EndIf
        
        
        If PORTD.1 = 0 Then 
        pause 100 
        hr1=hr1-1 
        If hr1<=0 Then hr1=0 
        EndIf
        
        GoSub ch_ust  
              
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300 
        X = 4 
        GoTo UstVREMY
        EndIf
        
  GoTo Ust_chasov
'=============================================================================  
  Ust_minut:  
           'pause 1000
        If PORTD.2 = 0 Then 
        pause 100:
        mins1 = mins1 + 1: 
        If mins1 >= 60 Then mins1 =59
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100 
        mins1 = mins1 - 1: 
        If mins1 <=0 Then mins1 = 0 
        EndIf
         
        GoSub min_ust
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1
         pause 300
          X = 5 
          GoTo UstVREMY 
          EndIf
  GoTo Ust_minut  
'=============================================================================  
  Ust_secund:
           'pause 1000
        If PORTD.2 = 0 Then 
        pause 100: 
        sec1 = sec1 + 1: 
        If sec1>=60 Then sec1 =59
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100 
        sec1 = sec1 - 1: 
        If sec1 <=0 Then sec1 = 0  
        EndIf
         
        GoSub sec_ust 
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300:
         X = 0 
         GoSub write_time 
         GoTo loop 
         EndIf
  GoTo Ust_secund    
'==========================================================================================  
  
    Fors_ckor:
    pause 300
    BranchL X, [Ust_fors_ob, Ust_imp_skor, Ust_imp_obor]
   
    If PORTD.0 = 0 Then 
    lcdout $fe,1
    pause 300
    lcdout $FE,$0C
    GoTo loop 
    EndIf 
    GoTo Fors_ckor
'=================================================================================    
    Ust_fors_ob:
        If PORTD.2 = 0 Then 
        pause 100: 
        f_obm= f_obm +1
        If f_obm>=5000 Then f_obm =5000
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100 
        f_obm = f_obm - 1 
        If f_obm <=0 Then f_obm = 0  
        EndIf
        
        lcdout $fe,1 
        GoSub fors_ust 
        pause 100
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300
         X = 1
         GoTo Fors_ckor
         EndIf
    GoTo Ust_fors_ob   
'==================================================================================  
       Ust_imp_skor:
       
        If PORTD.2 = 0 Then 
        pause 100: 
        sk_imp = sk_imp  +1
        If sk_imp >=5000 Then sk_imp=5000
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100 
        sk_imp  = sk_imp  - 1 
        If sk_imp  <=0 Then sk_imp  = 0  
        EndIf
        
        lcdout $fe,1 
        GoSub skor_ust 
        pause 100
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300
         X = 2
         GoTo Fors_ckor
         EndIf
         GoTo Ust_imp_skor
'=================================================================================================       
         Ust_imp_obor:
         If PORTD.2 = 0 Then 
        pause 100: 
        obr_imp  = obr_imp  +1
        If obr_imp  >=5000 Then obr_imp =5000
        EndIf
        
        If PORTD.1 = 0 Then 
        pause 100 
        obr_imp   = obr_imp   - 1 
        If obr_imp <=0 Then obr_imp  = 0  
        EndIf
        
        lcdout $fe,1 
        GoSub obor_ust 
        pause 100
        
        If PORTD.0 = 0 Then 
        lcdout $fe,1 
        pause 300
         X = 0
         EWrite 2,[f_obm]
         pause 100      
         EWrite 3,[sk_imp] 
         pause 100  
         EWrite 4,[obr_imp] 
         pause 100
         GoTo loop
         EndIf
         GoTo Ust_imp_obor
  
  
'====================  LCD   =======================================  

prosmotr:
lcdout $fe,1 
lcdout $fe,2
If c=1 Then Print At 1 ,1,$20,$20,$20,$E0,$41,$54,$41,$2D,$42,$50,$45,$4D,$B1
If c=2 Then Print At 1 ,1,$20,$20,$20,$20,$20,$4F,$A0,$4F,$50,$4F,$54,$AE
If c=3 Then Print At 1 ,1,$20,$20,$54,$45,$4D,$A8,$45,$50,$41,$54,$A9,$50,$41
If c=4 Then Print At 1 ,1,$20,$20,$20,$48,$41,$A8,$50,$B1,$A3,$45,$48,$A5,$45

If c=5 Then
Print At 1 ,1,$50,$41,$43,$58,$4F,$E0,$20,$54,$4F,$A8,$A7,$A5,$42,$41
Print At 2 ,1,$A4,$41,$20,$43,$45,$A1,$4F,$E0,$48,$B1
EndIf

If c=6 Then Print At 1 ,1,$20,$20,$20,$43,$4B,$4F,$50,$4F,$43,$54,$62

If c=7 Then 
Print At 1 ,1,$A8,$50,$4F,$A6,$E0,$45,$48,$48,$4F,$45
Print At 2 ,1,$50,$41,$43,$54,$4F,$B1,$48,$A5,$45
EndIf

If c=8 Then
Print At 1 ,1,$A8,$50,$4F,$A6,$E0,$45,$48,$48,$4F,$45
Print At 2 ,1,$50,$41,$43,$54,$4F,$B1,$48,$A5,$45,$20,$4F,$A0,$E2,$A5,$A6
EndIf 

If c=9 Then
Print At 1 ,1,$50,$41,$43,$58,$4F,$E0,$20,$4D,$A1,$4F,$42,$45,$48,$48,$AE,$A6
Print At 2 ,1,$BB,$2F,$31,$30,$30,$BA,$BC,$20,$B8,$BB,$B8,$20,$BB,$2F,$C0
EndIf


pause 1000 
Return

'==============      ====================== 
  god_ust: 
    Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$A1,$4F,$E0,$41
    lcdout $fe,$C0    
    lcdout  1,$E0,$41,$54,$41,$3A,$20, Dec2 date1,"-", Dec2 mon1,"-", Dec2 yr1
   Return

   mes_ust: 
   Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$4D,$45,$43,$B1,$E1,$41
   lcdout $fe,$C0    
   lcdout  1,$E0,$41,$54,$41,$3A,$20, Dec2 date1,"-", Dec2 mon1,"-", Dec2 yr1
   Return
 
 date_ust: 
    Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$AB,$A5,$43,$A7,$41
    lcdout $fe,$C0    
    lcdout  1,$E0,$41,$54,$41,$3A,$20, Dec2 date1,"-", Dec2 mon1,"-", Dec2 yr1
 Return
    
    ch_ust:
     Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$AB,$41,$43,$4F,$42
     lcdout $fe,$C0    
     lcdout 1,$42,$50,$45,$4D,$B1,$3A,$20,  Dec2 hr1,":", Dec2 mins1,":", Dec2 sec1
     Return
    
    min_ust:
    Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$4D,$A5,$48,$A9,$54
    lcdout $fe,$C0    
    lcdout 1,$42,$50,$45,$4D,$B1,$3A,$20,  Dec2 hr1,":", Dec2 mins1,":", Dec2 sec1
    Return
    
    
    sec_ust: 
    Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$43,$45,$4B,$A9,$48,$E0
    lcdout $fe,$C0    
    lcdout 1,$42,$50,$45,$4D,$B1,$3A,$20,  Dec2 hr1,":", Dec2 mins1,":", Dec2 sec1
    Return
'==============================================================================




'======================     ============
    fors_ust:
    Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$2D,$4F,$A0,$62,$45,$4D
    Print At 2 ,1,$AA,$4F,$50,$43,$A9,$48,$4B,$A5,":  ",#f_obm
    Return
'===================================================================================
  skor_ust:
  Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$A5,$4D,$A8,$A9,$A7,$2E
  Print At 2 ,1,$43,$4B,$4F,$50,$4F,$43,$54,$A5,":  ",#sk_imp 
  Return
'===================================================================================
  obor_ust:
  Print At 1 ,1,$A9,$43,$54,$41,$48,$4F,$42,$4B,$41,$20,$A5,$4D,$A8,$A9,$A7,$2E
  Print At 2 ,1,$4F,$A0,$4F,$50,$4F,$54,$4F,$42,$3A,$20,#obr_imp
  Return
'====================================================================================



 
'==============     ==================================== 
     PRNT3_4:  
    lcdout $fe,2 
    lcdout  " ",1,$E0,$41,$54,$41,$3A,$20, Dec2 date1,"-", Dec2 mon1,"-", Dec2 yr1
    lcdout $fe,$C0    
    lcdout 1,$42,$50,$45,$4D,$B1,$3A,$20,  Dec2 hr1,":", Dec2 mins1,":", Dec2 sec1
    Return
'====================   ===================    
     PRNTobor:
    lcdout $fe,1 
    lcdout 1,$4F,$A0,$4F,$50,$4F,$54,$AE,$3A,$20,$20,#value
    Return
'====================   LCD======================================= 
    temperatura:                             
    'lcdout $FE,$40,$0C,$12,$12,$0C,$00,$00,$00,$00  '    LCD    0 -   
    lcdout $fe,1    
   If minus=0 Then lcdout 1,$48,$41,$20,$A9,$A7,$A5,$E1,$45,$3A,$20," +",  Dec temperature
   If minus=1 Then lcdout 1,$48,$41,$20,$A9,$A7,$A5,$E1,$45,$3A,$20," -",  Dec temperature
     lcdout $fe,$C0     
   If minus1=0 Then lcdout 1,$E0,$42,$A5,$A1,$41,$54,$45,$A7,$62,$3A," +",  Dec temperature1
   If minus1=1 Then lcdout 1,$E0,$42,$A5,$A1,$41,$54,$45,$A7,$62,$3A," -",  Dec temperature1
    Return
 
 '==================   ================================ 
 
   PRNTnaprizenie:
    lcdout $fe,1  
    lcdout  1,$48,$41,$A8,$50,$3A,$20,"  ", Dec(VAR1/10),".",Dec2 VAR1,$B3,$2E
    Return

 
'======================    ===========================
racx_toplseg:
lcdout $fe,1  
Print At 1 ,1,$A5,$A4,$50,$41,$43,$58,$4F,$E0,$4F,$42,$41,$48,$4F,$20,$20
Print At 2 ,1,$54,$4F,$A8,$A7,$A5,$42,$41,$3A,Dec2 rcxtpslitr,".",Dec3 rcxtpsmililitr,$BB,$2E
Return

'==================     /100  /  
 racx_toplmgn:
lcdout $fe,1  
Print At 1 ,1,$50,$41,$43,$58,$4F,$E0,$20,$4D,$A1,$4F,$42,$45,$48,$48,$AE,$A6
Print At 2 ,1,"     ",Dec rsxtopmgnlitr,".",Dec rsxtopmgnmiliitr,$BB,$2E
Return

'========================== ==================================================
 
 scoroct:
 lcdout $fe,1  
 Print At 1,1,$43,$4B,$4F,$50,$4F,$43,$54,$62,$3A,$20,Dec scrkm,$BA,$BC
 Return
'========   ========================================== 
 prrasr_seg:
 lcdout $fe,1  
 Print At 1 ,1,$A8,$50,$4F,$A6,$E0,$45,$48,$48,$4F,$45,$20,$50,$41,$43,$54,$2E
 Print At 2 ,1,$43,$45,$A1,$4F,$E0,$48,$B1,$20,Dec raskm,".",Dec3 rasmetr,$BA,$BC
 Return
 
 '======== ========================================================== 
 prrasr_obch:
 lcdout $fe,1  
 Print At 1 ,1,$50,$41,$43,$54,$4F,$B1,$48,$A5,$45,$20,$4F,$A0,$E2,$A5,$A6
 Print At 2 ,1," ",Dec3 rastobtkm,Dec3 rastobskm,Dec3 rastobkm,$BA,$BC
 Return
'======================================================================================= 
 
 
 
 
 
 
 
 
'===================  ====================== 
 
oboroti:
count PORTB.0,1000,value
value=value*60
Return 
 
 
'======================== =================================== 
 
'--   DS1307--
read_time: 
I2Cread SDA, SCL, RTC_read, 0, [sec,mins,hr,day,date,mon,yr] 
tmp = sec 
GoSub fix_bcd_in
sec1 = tmp 
tmp = mins 
GoSub fix_bcd_in 
mins1 = tmp 
tmp = hr 
GoSub fix_bcd_in 
hr1 = tmp 
tmp = date 
GoSub fix_bcd_in 
date1 = tmp 
tmp = mon 
GoSub fix_bcd_in 
mon1 = tmp 
tmp = yr 
GoSub fix_bcd_in 
yr1 = tmp 
Return

'--   DS1307---
write_time:
tmp = sec1 
GoSub fix_bcd_out
sec = tmp 
tmp = mins1 
GoSub fix_bcd_out 
mins = tmp 
tmp = hr1 
GoSub fix_bcd_out 
hr = tmp 
tmp = date1 
GoSub fix_bcd_out 
date = tmp 
tmp = mon1 
GoSub fix_bcd_out 
mon = tmp 
tmp = yr1 
GoSub fix_bcd_out 
yr = tmp 
sec = 0 
I2Cwrite SDA, SCL, RTC_write, 0, [sec,mins,hr,day,date,mon,yr] 
Return
fix_bcd_in:
tmp1 = tmp & 15 
tmp = tmp >> 4 
tmp = tmp1 + 10 * tmp 
Return 
fix_bcd_out:
tmp1 = tmp / $A 
tmp = tmp - (tmp1 * $A) 
tmp = tmp + (tmp1 << 4) 
Return 



'*******************************************************************
'*    /                  *
'*******************************************************************    
term:   
    OWOut DQ, 1, [$CC, $44]      '   
    tm:
    OWIn DQ, 4, [count_remain]	 '  
	If count_remain = 0 Then  GoTo tm
   
    
                                '  
	OWOut DQ, 1, [$CC, $BE]		
    OWIn DQ, 0, [temperature.LowByte, temperature.HighByte, Skip 4, count_remain, count_per_c]

	'     C 
    '(    )
	  
       temperature = ((temperature * 10)>>4)
       
       If  temperature>1000 Then 
           temperature =4096 - temperature 
        minus=1
        Else
        minus=0
        EndIf
        temperature = temperature /10 
        
	    Return
	    
'*******************************************************************
'*    /                *
'*******************************************************************    
term1:   
    OWOut DQ1, 1, [$CC, $44]      '   
    tm1:
    OWIn DQ1, 4, [count_remain1]	 '  
	If count_remain1 = 0 Then  GoTo tm1
   
    
                                '  
	OWOut DQ1, 1, [$CC, $BE]		
    OWIn DQ1, 0, [temperature1.LowByte, temperature1.HighByte, Skip 4, count_remain1, count_per_c1]

	'     C 
    '(    )
	  
       temperature1 = ((temperature1 * 10)>>4)
       
       If  temperature1>1000 Then 
           temperature1 =4096 - temperature1 
        minus1=1
        Else
        minus1=0
        EndIf
        temperature1 = temperature1 /10 
        
	    Return
	    
'********************************************************************
'************    /      **********
'************** *****************************************************    

naprizenie:
ADcIn 0,VAR2 
VAR1=((var2+1) */ 500)>>2
Return

End








